package config

import (
	"fmt"
	"testing"

	"github.com/sirupsen/logrus"
	"github.com/spf13/viper"
	"gogs.daxia.dev/huanan/pkg.daxia.dev.git/rdb"
)

func Setup() {
	viper.Set("rdb.addr", "localhost:6379")
	viper.Set("rdb.password", "")
	viper.Set("rdb.db", "1")
	viper.Set("rdb.pool_size", "100")

	err := rdb.InitClient()
	if err != nil {
		logrus.Fatal(err)
	}
}

func TestConfig(t *testing.T) {

	Setup()

	SetString("test_data1", "test")

	data := GetString("test_data1", "empty")
	if data != "test" {
		t.Fatal(`data != "test"`)
	}

	SetInt("test_data2", 1)
	intData := GetInt("test_data2", -1)
	if intData != 1 {
		t.Fatal(`intData != 1`)
	}
}

func TestList(t *testing.T) {
	Setup()

	InitPrefix("test_config")

	SetString("test_data1", "test1")
	SetString("test_data2", "test2")
	SetInt("test_data3", 1)

	resultMap, err := ListAll()
	if err != nil {
		t.Fatal(err)
	}

	if len(resultMap) != 3 {
		t.Fatal("len(resultMap) != 3")
	}

	fmt.Println(resultMap)
}
